/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#ifdef HAVE_CONFIG_H
# include <config.h>
#endif
#include <sys/types.h>

static size_t debug_handle;
/* This must be defined before including debug.h */
#define MF_SOURCE_NAME  debug_handle

#include "mailfromd.h"
#include "prog.h"
#include "builtin.h"

#line 1 "sa.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2006, 2007, 2008, 2009, 2010 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */

#include <unistd.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <string.h>
#include <signal.h>

static size_t sa_score_loc
#line 25 "sa.bi"
;
static size_t sa_threshold_loc
#line 26 "sa.bi"
;
static size_t sa_keywords_loc
#line 27 "sa.bi"
;
static size_t clamav_virus_name_loc
#line 28 "sa.bi"
;

static int
spamd_connect(eval_environ_t env, mu_stream_t *stream, char *host, int port)
{
	int rc;
	char *fname;
	
	if (port) {
		fname = "mu_tcp_stream_create";
		rc = mu_tcp_stream_create(stream, host, port,
					  MU_STREAM_NO_CHECK);
	} else {
		fname = "mu_socket_stream_create";
		rc = mu_socket_stream_create(stream, host, MU_STREAM_NO_CHECK);
	}
	
		if (!(rc == 0))
#line 45
			env_throw_bi(env, mfe_failure, NULL, "%s: %s",fname,mu_strerror(rc))
#line 47
;
	rc = mu_stream_open(*stream);
		if (!(rc == 0))
#line 49
			env_throw_bi(env, mfe_failure, NULL, "mu_stream_open: %s",mu_strerror(rc))
#line 51
;
	return rc;
}

static void
spamd_destroy(mu_stream_t *stream)
{
	mu_stream_close(*stream);
	mu_stream_destroy(stream, NULL);
}

static void
spamd_send_command(mu_stream_t stream, const char *fmt, ...)
{
	char buf[512];
	size_t n;
	va_list ap;
	
	va_start (ap, fmt);
	n = vsnprintf (buf, sizeof buf, fmt, ap);
	va_end (ap);
	mu_stream_sequential_write(stream, buf, n);
	mu_stream_sequential_write(stream, "\r\n", 2);
}

/* Write SIZE bytes from BUF to STREAM, converting every \n to \r\n.
   Note that it assumes that BUF itself does not contain any \r\n sequences. 
   This is always true for captured message streams (see env_capture_write
   in prog.c).
   FIXME (mailutils): We cannot use MU's RFC822 filter for that purpose,
   because (as of v. 2.0.90) there is no way to destroy it without
   closing and destroying the transport stream.
 */
static int
write_822(mu_stream_t stream, char *buf, size_t size)
{
	int rc = 0;
	while (size) {
		size_t len = mem_search(buf, '\n', size);
		rc = mu_stream_sequential_write(stream, buf, len);
		if (rc)
			break;
		if (buf[len] == '\n') {
			rc = mu_stream_sequential_write(stream, "\r\n", 2);
			if (rc)
				break;
			len++;
		}
		buf += len;
		size -= len;
	}
	return rc;
}

static int
spamd_send_stream(mu_stream_t ostr, mu_stream_t istr)
{
	size_t size;
	char buf[512];
	int rc;
	
	mu_stream_seek(istr, 0, SEEK_SET);
	while ((rc = mu_stream_sequential_readline(istr, buf, sizeof(buf),
						   &size)) == 0
	       && size > 0) {
		debug3(80,"<< %*.*s", size, size, buf);
		rc = write_822(ostr, buf, size);
		if (rc)
			break;
	}
	return rc;
}

static int
spamd_read_line0(mu_stream_t stream, char *buffer, size_t size, size_t *pn)
{
	size_t n = 0;
	int rc = mu_stream_sequential_readline(stream, buffer, size, &n);
	if (rc == 0) {
		debug3(80,">> %*.*s", n, n, buffer);
		if (pn)
			*pn = n;
	}
	return rc;
}

static int
spamd_read_line(mu_stream_t stream, char *buffer, size_t size)
{
	size_t n;
	int rc = spamd_read_line0(stream, buffer, size, &n);
	if (rc == 0) {
		while (n > 0 && (buffer[n-1] == '\r' || buffer[n-1] == '\n'))
			n--;
		buffer[n] = 0;
	}
	return rc;
}

#define char_to_num(c) (c-'0')

static void
decode_float(long *vn, char *str, int digits)
{
	long v;
	size_t frac = 0;
	size_t base = 1;
	int i;
	int negative = 0;
  
	for (i = 0; i < digits; i++)
		base *= 10;
  
	v = strtol(str, &str, 10);
	if (v < 0) {
		negative = 1;
		v = - v;
	}
  
	v *= base;
	if (*str == '.') {
		for (str++, i = 0; *str && i < digits; i++, str++)
			frac = frac * 10 + char_to_num (*str);
		if (*str) {
			if (char_to_num(*str) >= 5)
				frac++;
		}
		else
			for (; i < digits; i++)
				frac *= 10;
	}
	*vn = v + frac;
	if (negative)
		*vn = - *vn;
}

static int
decode_boolean (char *str)
{
	if (strcasecmp (str, "true") == 0)
		return 1;
	else if (strcasecmp (str, "false") == 0)
		return 0;
	/*else?*/
	return 0;
}

typedef RETSIGTYPE (*signal_handler_fn)(int);

static signal_handler_fn
set_signal_handler (int sig, signal_handler_fn h)
{
#ifdef HAVE_SIGACTION
	struct sigaction act, oldact;
	act.sa_handler = h;
	sigemptyset (&act.sa_mask);
	act.sa_flags = 0;
	sigaction (sig, &act, &oldact);
	return oldact.sa_handler;
#else
	return signal (sig, h);
#endif
}

static int got_sigpipe;

static RETSIGTYPE
sigpipe_handler (int sig)
{
	got_sigpipe = 1;
}

mu_stream_t
open_connection(eval_environ_t env, char *urlstr, char **phost)
{
	char *path = NULL;
	short port = 0;
	mu_stream_t str = NULL;
	int rc;
	
	if (urlstr[0] == '/') {
		path = strdup(urlstr);
		if (!path)
			runtime_error(env, _("not enough memory"));
	} else {
		char buffer[10];
		mu_url_t url = NULL;
		
		rc = mu_url_create(&url, urlstr);
		if (rc)
				env_throw_bi(env, mfe_failure, NULL, _("cannot create URL from `%s': %s"),urlstr,mu_strerror(rc));
#line 244
		
		if (rc = mu_url_parse(url)) {
			mu_url_destroy(&url);
				env_throw_bi(env, mfe_url, NULL, _("%s: error parsing URL: %s"),urlstr,mu_strerror(rc));
#line 250
		}

		if (rc = mu_url_get_scheme(url, buffer, sizeof buffer, NULL)) {
			mu_url_destroy(&url);
				env_throw_bi(env, mfe_url, NULL, _("%s: cannot get scheme: %s"),urlstr,mu_strerror(rc));
#line 257
		}

		if (strcmp(buffer, "file") == 0
		    || strcmp(buffer, "socket") == 0) {
			size_t size;
			if (rc = mu_url_get_path(url, NULL, 0, &size)) {
					env_throw_bi(env, mfe_url, NULL, _("%s: cannot get path: %s"),urlstr,mu_strerror(rc));
#line 266
			}
			path = malloc(size + 1);
			if (!path) {
				mu_url_destroy(&url);
				runtime_error(env, _("not enough memory"));
			}
			mu_url_get_path(url, path, size + 1, NULL);
		} else if (strcmp(buffer, "tcp") == 0) {
			size_t size;
			long n;
			
			if (rc = mu_url_get_port(url, &n)) {
				mu_url_destroy(&url);
					env_throw_bi(env, mfe_url, NULL, _("%s: cannot get port: %s"),urlstr,mu_strerror(rc));
#line 282
			}

			if (n == 0 || (port = n) != n) {
				mu_url_destroy(&url);
					env_throw_bi(env, mfe_range, NULL, _("port out of range: %ld"),n);
#line 289
			}
			
			if (rc = mu_url_get_host(url, NULL, 0, &size)) {
				mu_url_destroy(&url);
					env_throw_bi(env, mfe_url, NULL, _("%s: cannot get host: %s"),urlstr,mu_strerror(rc));
#line 296
			}
			path = malloc(size + 1);
			if (!path) {
				mu_url_destroy(&url);
				runtime_error(env, _("not enough memory"));
			}
			mu_url_get_host(url, path, size + 1, NULL);
		} else
				env_throw_bi(env, mfe_url, NULL, _("invalid URL: %s"),buffer);
#line 306

		mu_url_destroy(&url);
	}

	rc = spamd_connect(env, &str, path, port);
	
	if (rc == 0 && phost) {
		if (port) {
			*phost = path;
			path = NULL;
		} else
			*phost = NULL;
	}

	free(path);

	return str;
}	


	
void
#line 327
bi_sa(eval_environ_t env)
#line 327

#line 327 "sa.bi"
{
#line 327
	
#line 327

#line 327
long __bi_argcnt;
#line 327
char * urlstr;
#line 327
        long  prec;
#line 327
        long  report;
#line 327
        
#line 327
get_string_arg(env, 1, &urlstr);
#line 327
        get_numeric_arg(env, 2, &prec);
#line 327
        get_numeric_arg(env, 3, &report);
#line 327
        
#line 327
get_numeric_arg(env, 0, &__bi_argcnt);
#line 327
        adjust_stack(env, __bi_argcnt + 1);
#line 327

#line 327
	if (builtin_module_trace(BUILTIN_IDX_sa))
#line 327
		prog_trace(env, "sa %s %lu %lu",urlstr, prec, ((__bi_argcnt > 2) ? report : 0));;
#line 327

{
	mu_off_t msize;
	size_t size;
	mu_stream_t mstr = env_get_stream(env);
	mu_stream_t ostr;
	signal_handler_fn handler;
	char buffer[512];
	char version_str[19];
	char spam_str[6], score_str[21], threshold_str[21];
	long version;
	int result;
	long score, threshold;
	int report_mode = ((__bi_argcnt > 2) ? report : 0);
	int rc;
	
	rc = mu_stream_size(mstr, &msize);
		if (!(rc == 0))
#line 344
			env_throw_bi(env, mfe_failure, "sa", "mu_stream_size: %s",mu_strerror (rc))
#line 347
;

	ostr = open_connection(env, urlstr, NULL);
	msize += env_get_line_count(env);
	spamd_send_command(ostr,
			   report_mode ? "REPORT SPAMC/1.2"
			               : "SYMBOLS SPAMC/1.2");
	spamd_send_command(ostr, "Content-length: %lu",
			   (unsigned long) msize);
	/*FIXME: spamd_send_command(ostr, "User: %s", ??) */
	got_sigpipe = 0;
	handler = set_signal_handler(SIGPIPE, sigpipe_handler);
	spamd_send_command(ostr, "");
	if (rc = spamd_send_stream(ostr, mstr)) {
		spamd_destroy(&ostr);
			env_throw_bi(env, mfe_failure, "sa", _("send stream failed: %s"),mu_strerror (rc));
#line 365
	}
	mu_stream_shutdown(ostr, MU_STREAM_WRITE);
	set_signal_handler(SIGPIPE, handler);
	
	spamd_read_line(ostr, buffer, sizeof buffer);
	if (got_sigpipe) {
		spamd_destroy(&ostr);
			env_throw_bi(env, mfe_failure, "sa", _("remote side has closed connection"));
	}

	if (sscanf(buffer, "SPAMD/%18s %d %*s", version_str, &result) != 2) {
		spamd_destroy(&ostr);
			env_throw_bi(env, mfe_failure, "sa", _("spamd responded with bad string '%s'"),buffer);
#line 380
	}

	decode_float(&version, version_str, 1);
	if (version < 10) {
		spamd_destroy(&ostr);
			env_throw_bi(env, mfe_failure, "sa", _("unsupported SPAMD version: %s"),version_str);
#line 388
	}

	spamd_read_line(ostr, buffer, sizeof buffer);
	if (sscanf (buffer, "Spam: %5s ; %20s / %20s",
		    spam_str, score_str, threshold_str) != 3) {
		spamd_destroy(&ostr);
			env_throw_bi(env, mfe_failure, "sa", _("spamd responded with bad Spam header '%s'"),buffer);
#line 397
	}

	result = decode_boolean(spam_str);
	decode_float(&score, score_str, prec);
	decode_float(&threshold, threshold_str, prec);

	*env_data_ref(env, sa_score_loc) = (STKVAL) (score);
	*env_data_ref(env, sa_threshold_loc) = (STKVAL) (threshold);

	/* Skip newline */
	spamd_read_line(ostr, buffer, sizeof buffer);
	if (report_mode) {
		heap_obstack_begin(env);
		while (spamd_read_line0(ostr, buffer, sizeof buffer, &size)
		       == 0
		       && size > 0) 
			heap_obstack_grow(env, buffer, size);
		do { char __c = 0; heap_obstack_grow(env, &__c, 1); } while(0);
		*env_data_ref(env, sa_keywords_loc) = (STKVAL) (heap_obstack_finish(env));
	} else {
		/* Read symbol list */
		spamd_read_line(ostr, buffer, sizeof buffer);

		
#line 420
{ size_t __off;
#line 420
  const char *__s = buffer;
#line 420
  if (__s)
#line 420
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 420
  else
#line 420
     __off = 0;
#line 420
  *env_data_ref(env, sa_keywords_loc) = (STKVAL) (__off); }
#line 420
;
	
		while (spamd_read_line0(ostr, buffer, sizeof buffer, &size)
		       == 0
		       && size > 0)
			/* Drain input */;
	}
  	spamd_destroy(&ostr);
	
	
#line 429
do {
#line 429
  push(env, (STKVAL) (result));
#line 429
  return;
#line 429
} while (0);
}
}


	
void
#line 435
bi_clamav(eval_environ_t env)
#line 435

#line 435 "sa.bi"
{
#line 435
	
#line 435

#line 435

#line 435
char * urlstr;
#line 435
        
#line 435
get_string_arg(env, 0, &urlstr);
#line 435
        
#line 435

#line 435
        adjust_stack(env, 1);
#line 435

#line 435
	if (builtin_module_trace(BUILTIN_IDX_sa))
#line 435
		prog_trace(env, "clamav %s",urlstr);;
#line 435

{
	mu_stream_t mstr = env_get_stream(env);
	mu_stream_t cstr, dstr;
	char buffer[512];
	char *host;
	unsigned short port;
	int rc;
	signal_handler_fn handler;
	char *p;
	
	cstr = open_connection(env, urlstr, &host);

	spamd_send_command(cstr, "STREAM");
	spamd_read_line(cstr, buffer, sizeof buffer);
	if (sscanf(buffer, "PORT %hu\n", &port) != 1) {
		spamd_destroy(&cstr);
			env_throw_bi(env, mfe_failure, "clamav", _("bad response from clamav: expected `PORT' but found `%s'"),buffer);
#line 455
	}

	if (!host) 
		host = strdup("127.0.0.1"); /* FIXME */
	
	rc = mu_tcp_stream_create(&dstr, host, port, 0);
	free(host);
	if (rc) {
		spamd_destroy(&cstr);
			env_throw_bi(env, mfe_failure, "clamav", "mu_tcp_stream_create: %s",mu_strerror(rc));
#line 467
	}

	rc = mu_stream_open(dstr);
	if (rc) {
		spamd_destroy(&cstr);
		mu_stream_destroy(&dstr, mu_stream_get_owner(dstr));
			env_throw_bi(env, mfe_failure, "clamav", "mu_stream_open: %s",mu_strerror(rc));
#line 476
	}

	handler = set_signal_handler(SIGPIPE, sigpipe_handler);
	rc = spamd_send_stream(dstr, mstr);
	mu_stream_shutdown(dstr, MU_STREAM_WRITE);
	spamd_destroy(&dstr);
	set_signal_handler(SIGPIPE, handler);
	if (rc) {
		spamd_destroy(&cstr);
			env_throw_bi(env, mfe_failure, "clamav", _("sending to stream failed: %s"),mu_strerror (rc));
#line 488
	}

	rc = spamd_read_line(cstr, buffer, sizeof buffer);
	spamd_destroy(&cstr);
		if (!(rc == 0))
#line 492
			env_throw_bi(env, mfe_failure, "clamav", _("error reading clamav response: %s"),mu_strerror(rc))
;

	p = strrchr(buffer, ' ');
        	if (!(p))
#line 496
			env_throw_bi(env, mfe_failure, "clamav", _("unknown clamav response: %s"),buffer)
;
	++p;
	if (strncmp(p, "OK", 2) == 0)
		rc = 0;
	else if (strncmp(p, "FOUND", 5) == 0) {
		char *s;
			
		*--p = '\0';
		s = strrchr(buffer, ' ');
		if (!s)
			s = buffer;
		else
			s++;
		
#line 510
{ size_t __off;
#line 510
  const char *__s = s;
#line 510
  if (__s)
#line 510
     strcpy((char*)env_data_ref(env, __off = heap_reserve(env, strlen(__s) + 1)), __s);
#line 510
  else
#line 510
     __off = 0;
#line 510
  *env_data_ref(env, clamav_virus_name_loc) = (STKVAL) (__off); }
#line 510
;

		debug2(2,
		       "%sclamav found %s",
		       mailfromd_msgid(env_get_context(env)),
		       s);
		rc = 1;
	} else if (strncmp(p, "ERROR", 5) == 0) {
		/* FIXME: mf code */
			env_throw_bi(env, mfe_failure, "clamav", _("clamav error: %s"),buffer);
#line 522
	} else {
			env_throw_bi(env, mfe_failure, "clamav", _("unknown clamav response: %s"),buffer);
#line 526
	}

	
#line 528
do {
#line 528
  push(env, (STKVAL) (rc));
#line 528
  return;
#line 528
} while (0);
}
}


#line 532
void
#line 532
sa_init_builtin()
#line 532
{
#line 532
        debug_handle = debug_register("bi_sa");
#line 532
	#line 25 "sa.bi"
	builtin_variable_install("sa_score", dtype_number, SYM_VOLATILE, &sa_score_loc);
#line 26 "sa.bi"
	builtin_variable_install("sa_threshold", dtype_number, SYM_VOLATILE, &sa_threshold_loc);
#line 27 "sa.bi"
	builtin_variable_install("sa_keywords", dtype_string, SYM_VOLATILE, &sa_keywords_loc);
#line 28 "sa.bi"
	builtin_variable_install("clamav_virus_name", dtype_string, SYM_VOLATILE, &clamav_virus_name_loc);
#line 327 "sa.bi"
va_builtin_install_ex("sa", bi_sa, STATMASK(smtp_state_eom), dtype_number, 3, 1, MFD_BUILTIN_CAPTURE|0, dtype_string, dtype_number, dtype_number);
#line 435 "sa.bi"
va_builtin_install_ex("clamav", bi_clamav, STATMASK(smtp_state_eom), dtype_number, 1, 0, MFD_BUILTIN_CAPTURE|0, dtype_string);

#line 532 "sa.bi"
	
#line 532
}
#line 532


#line 627 "../../mfd/builtin/snarf.m4"

#line 627

